<% @Page Language="C#" %>
<%@ Import Namespace="System.IO"%>

<script runat="server">

    private void Page_Load(object source, EventArgs e){
        /* Security fix: Missing X-Frame-Options */
        Response.AddHeader("X-Frame-Options", "DENY");
        savedConfigUrl.InnerHtml = getSavedMobileServerURL();
        // if (isDebugModeEnabled()) {
        //     debugMode.Checked = true;
        // }
    }

    private void onSubmit(object sender, EventArgs e) {
        
        // if (isEDMChecked()) {
        //     setDebugFlag(true);
        // }
        // else {
        //     setDebugFlag(false);
        // }
        //debugMode.Checked = isDebugModeEnabled();
        
        String urlConfig = getMobileConfigURL();
        if (!string.IsNullOrEmpty(urlConfig)){
            insertMobileServerURL(urlConfig);
            savedConfigUrl.InnerHtml = getSavedMobileServerURL();
        }
    }

    private String getPackageName() {
        return "VitaraMaps";
    }
    private String getPackageSampleChart(){
        return "VitaraMapsLibrary";
    }
    private Boolean belongsToPackage(String chart){
        Boolean result = false;
        if (chart.StartsWith("Vitara") && !chart.Equals(getPackageName())) {
            result = true;
        }
        if (getPackageName().Contains("Charts") && chart.Contains("VitaraMapsLibrary")) {
            result = false;
        }
        else if (getPackageName().Contains("Maps") && !chart.Contains("VitaraMapsLibrary")) {
            result = false;
        }
        return result;
    }
    private String getPluginsRoot(){
        return Server.MapPath("~") + "\\plugins\\";
        //return Server.MapPath("~");
    }
    private String getChartsRoot(){
        return getPluginsRoot() + "VitaraMapsLibrary\\";
    }
    private String getSourceRoot(){
        return getChartsRoot() + "javascript\\mojo\\js\\source\\";
    }
    private String getDebugFilePath(){
        return getPluginsRoot() + "VitaraHCBarChartMobile\\javascript\\mojo\\js\\source\\VitaraHCBarChartLibrary.js";
    }
    private String getMobileServerFilePath(String dir){
        return getPluginsRoot() + dir + "\\javascript\\mojo\\js\\source\\MobileServerUrl.js";
    }
    private String getMobileConfigURL(){
        return mobileConfigUrl.Value;
    }
    private Boolean isEDMChecked(){
        return debugMode.Checked;
    }
    private String getRegExMatch(String config, String pattern){
        String result = "";
        MatchCollection matches = Regex.Matches(config, pattern);
        //temp as all regex yields single match.
        foreach(Match match in matches){
            result = match.ToString();
        }
        return result;
    }
    private String extractURI(String config){
        return Server.UrlDecode(getRegExMatch(config, "http.+?(?=servlet|api|asp)"));
    }
    private List<string> getDirs(String path){
        List<string> dirs = new List<string>(Directory.EnumerateDirectories(path));
        List<string> res = new List<string>();
        foreach(String dir in dirs){
            res.Add(dir.Substring(dir.LastIndexOf("\\") + 1));
        }
        return res;
    }
    private String readFile(String filePath){
        String text = "";
        using (StreamReader sr = new StreamReader(filePath)) {
                text = sr.ReadToEnd();
        }
        return text;
    }
    private void createFile(String path, String data){
        using (FileStream fs = File.Create(path)) {
            Byte[] info = new UTF8Encoding(true).GetBytes(data);
            fs.Write(info, 0, info.Length);
        }
    }
    private void deleteFile(String path){
        if (File.Exists(path)) {
            File.Delete(path);
        }
    }
    private String getStringUrlFun(String url, String dirName){
        return "(function(){if(!mstrmojo.plugins." + dirName + ") mstrmojo.plugins."+dirName+"={};mstrmojo.plugins."+dirName+".MobileServerUrl=Object;window.getMobileServerURL =  function getMobileServerURL(){return '" + url + "';}}());";
    }
    private String getSavedMobileServerURL(){
        String result = "";
        String fPath = getMobileServerFilePath(getPackageSampleChart());
        if (File.Exists(fPath)){
            String content = readFile(fPath);
            result = getRegExMatch(content, "http.+?(?=';})");
        }
        return result;
    }
    private Boolean isDebugModeEnabled(){
        String result = "false";
        String path = getDebugFilePath();
        String content = readFile(path);
        result = getRegExMatch(content, "(?<=var isVitaraMobileDebug = )true|false");
        return Boolean.Parse(result);
    }
    private Boolean isRegExMatch(String content, String regEx){
        return Regex.IsMatch(content, regEx);
    }
    private void setDebugFlag(Boolean mBool){
        String path = getDebugFilePath();
        String content = readFile(path);
        if (Regex.IsMatch(content, "var isVitaraMobileDebug\\s*=\\s*true|var isVitaraMobileDebug\\s*=\\s*false")) {
            if (mBool) {
                content = Regex.Replace(content, "var isVitaraMobileDebug\\s*=\\s*true|var isVitaraMobileDebug\\s*=\\s*false", "var isVitaraMobileDebug = true");
            }
            else {
                content = Regex.Replace(content, "var isVitaraMobileDebug\\s*=\\s*true|var isVitaraMobileDebug\\s*=\\s*false", "var isVitaraMobileDebug = false");                
            }
        }
        createFile(path, content);
    }
    private void insertMobileServerURL(String strConfig){
        List<String> dirs = getDirs(getPluginsRoot());
        String mUri = extractURI(strConfig);
        if (mUri != null) {
            foreach(String dir in dirs){
                if (belongsToPackage(dir)) {
                    createFile(getMobileServerFilePath(dir), getStringUrlFun(mUri));
                }
            }
        }
    }
</script>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
        <style>
            .vtrButton {
                width: 80px;
                height: 25px;
            }

            .inputBox {
                width: 350px;
                height: 150px;
                box-sizing: border-box;
                border: 1px solid #e0e0e0;
                border-radius: 4px;
                background-color: #fcfcfc;
                padding: 3px;
                resize: none;
            }

            body {
                font-family: Arial, Helvetica, sans-serif;
                font-size: 14px;
            }

            label {
                color: blue;
            }
        </style>
    </head>
    <body>
        <form runat="server">
            <!-- <br> Enable Debug Mode:
            <input runat="server" type="checkbox" name="debugMode" id="debugMode">
            <br> -->
            <br> Mobile Configuration URL:
            <br>
            <textarea runat="server" type="text" name="mobileConfigUrl" id="mobileConfigUrl" class="inputBox"></textarea>
            <br>
            <label runat="server" id="savedConfigUrl">
            </label>
            <br>
            <br>
            <input runat="server" id="formSubmit" class="vtrButton" type="submit" value="Submit" OnServerClick="onSubmit">
        </form>
    </body>
</html>